"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GenericValueGenerator = /** @class */ (function () {
    function GenericValueGenerator(base) {
        this.base = base;
    }
    GenericValueGenerator.prototype.generate = function (type, container) {
        var _this = this;
        var result = {};
        var genericTypes = [];
        var genericValues = [];
        var baseType = container.find(function (item) { return item.name === type.split('<')[0]; });
        var matches = type.match(/(?<=\<)(.*?)(?=\>)/g);
        if (baseType && matches && matches.length) {
            genericTypes = matches[0].split(',').map(function (type) { return type.trim(); });
            genericValues = genericTypes.map(function (item) { return _this.base.resolveAndGenerate(item); });
            result = this.base.resolveAndGenerate(baseType.name);
            Object.keys(result).forEach(function (key) {
                var index = baseType.typeParameters.findIndex(function (item) { return item === result[key]; });
                if (index >= 0) {
                    result[key] = genericValues[index];
                }
            });
        }
        return result;
    };
    return GenericValueGenerator;
}());
exports.GenericValueGenerator = GenericValueGenerator;
