"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var faker_1 = __importDefault(require("faker"));
var PrimitiveType;
(function (PrimitiveType) {
    PrimitiveType["Number"] = "number";
    PrimitiveType["Boolean"] = "boolean";
    PrimitiveType["String"] = "string";
    PrimitiveType["Null"] = "null";
    PrimitiveType["Undefined"] = "undefined";
})(PrimitiveType = exports.PrimitiveType || (exports.PrimitiveType = {}));
var PrimitiveValueGenerator = /** @class */ (function () {
    function PrimitiveValueGenerator(base) {
        this.base = base;
    }
    PrimitiveValueGenerator.prototype.generate = function (type, container) {
        switch (type) {
            case PrimitiveType.Boolean:
                return faker_1.default.random.boolean();
            case PrimitiveType.String:
                var words = faker_1.default.random.word();
                return words.split(' ')[0];
            case PrimitiveType.Number:
                return faker_1.default.random.number();
            case PrimitiveType.Null:
                return null;
            case PrimitiveType.Undefined:
                return undefined;
            default:
                return undefined;
        }
    };
    return PrimitiveValueGenerator;
}());
exports.PrimitiveValueGenerator = PrimitiveValueGenerator;
