"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeResolver_1 = require("../resolvers/typeResolver");
var getRandomNumberBetween_1 = require("../utils/getRandomNumberBetween");
var typeChecker_1 = require("../../typeChecker");
var ValueGeneratorBase = /** @class */ (function () {
    function ValueGeneratorBase(container) {
        this.container = container;
        this.typeResolver = new typeResolver_1.TypeResolver(this);
        this.generate = this.generate.bind(this);
        this.resolveAndGenerate = this.resolveAndGenerate.bind(this);
    }
    ValueGeneratorBase.prototype.generate = function (type) {
        var _this = this;
        var result = {};
        var declaration = this.container.find(function (item) { return item.name === type; });
        if (declaration) {
            if (declaration.type === typeChecker_1.Declaration.Interface) {
                declaration.properties.forEach(function (item) {
                    var _a;
                    var value = item.isGeneric ? item.type : _this.resolveAndGenerate(item.type);
                    result = __assign(__assign({}, result), (_a = {}, _a[item.name] = value, _a));
                });
            }
            else {
                var rnd = getRandomNumberBetween_1.getRandomNumberBetween(0, declaration.properties.length);
                result = declaration.properties[rnd].value;
            }
        }
        else {
            result = this.resolveAndGenerate(type, false);
        }
        return result;
    };
    ValueGeneratorBase.prototype.resolveAndGenerate = function (type, isKnownType) {
        if (isKnownType === void 0) { isKnownType = true; }
        var generator = this.typeResolver.resolve(type);
        if (generator) {
            return generator.generate(type, this.container);
        }
        if (!isKnownType)
            return;
        return this.generate(type);
    };
    ValueGeneratorBase.prototype.isKnownType = function (type) {
        return true;
    };
    return ValueGeneratorBase;
}());
exports.ValueGeneratorBase = ValueGeneratorBase;
