"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fast_glob_1 = __importDefault(require("fast-glob"));
var valueGeneratorBase_1 = require("./generators/valueGeneratorBase");
var typeChecker_1 = require("../typeChecker");
var defaultOptions = {
    ignoreGlob: [],
    additionalFiles: []
};
var FixtureRepository = /** @class */ (function () {
    function FixtureRepository() {
    }
    FixtureRepository.setup = function (pattern, options) {
        if (options === void 0) { options = defaultOptions; }
        var additionalFiles = options.additionalFiles || defaultOptions.additionalFiles;
        var fileNames = fast_glob_1.default.sync(pattern, this.getOptions(options));
        fileNames = fileNames.concat(additionalFiles);
        var typeChecker = new typeChecker_1.TypeChecker(fileNames);
        this.container = typeChecker.generateContainer();
        this.valueGenerator = new valueGeneratorBase_1.ValueGeneratorBase(this.container);
    };
    FixtureRepository.create = function (type) {
        return this.valueGenerator.resolveAndGenerate(type);
    };
    FixtureRepository.getOptions = function (options) {
        return {
            onlyFiles: true,
            unique: true,
            ignore: options.ignoreGlob || defaultOptions.ignoreGlob
        };
    };
    return FixtureRepository;
}());
exports.default = FixtureRepository;
