"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var primitiveValueGenerator_1 = require("../generators/primitiveValueGenerator");
function isPrimitive(type) {
    var typeToCheck = type.toLowerCase();
    return (typeToCheck === primitiveValueGenerator_1.PrimitiveType.Boolean ||
        typeToCheck === primitiveValueGenerator_1.PrimitiveType.String ||
        typeToCheck === primitiveValueGenerator_1.PrimitiveType.Null ||
        typeToCheck === primitiveValueGenerator_1.PrimitiveType.Number ||
        typeToCheck === primitiveValueGenerator_1.PrimitiveType.Undefined);
}
exports.isPrimitive = isPrimitive;
function isArray(type) {
    return type.endsWith('[]');
}
exports.isArray = isArray;
function isUnion(type) {
    return type.includes('|');
}
exports.isUnion = isUnion;
function isIntersect(type) {
    return type.includes('&');
}
exports.isIntersect = isIntersect;
function isGeneric(type) {
    return type.includes('<') && type.endsWith('>');
}
exports.isGeneric = isGeneric;
