export declare enum Declaration {
    Interface = 0,
    Enum = 1,
    Type = 2
}
export declare type Container = ContainerItem[];
export interface Property {
    name: string;
    type: string;
    isGeneric: boolean;
    value?: any;
}
export interface ContainerItem {
    type: Declaration;
    name: string;
    properties: Property[];
    typeParameters: string[];
    isGeneric: boolean;
}
export declare class TypeChecker {
    private project;
    constructor(files: string[]);
    generateContainer(): Container;
    private getContainerItemsFromFiles;
    private mapInterfaceProperties;
    private mapEnumMembers;
}
